/**************************************************************************

	ns

	memory.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "string.h"


/**************************************************************************
	Define
**************************************************************************/

/**************************************************************************
	Global Variables
**************************************************************************/

/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	MemAlloc

	obt@m

******************************************************************************/

void *MemAlloc(int size)
{
	return LocalAlloc(LMEM_FIXED, size);
}


/******************************************************************************

	MemFree

	obt@

******************************************************************************/

void MemFree(void **mem)
{
	if(*mem != NULL){
		LocalFree(*mem);
		*mem = NULL;
	}
}


/******************************************************************************

	AllocCopy

	obt@mۂĕRs[

******************************************************************************/

TCHAR *AllocCopy(const TCHAR *buf)
{
	TCHAR *ret;

	if(buf == NULL){
		return NULL;
	}
	ret = (TCHAR *)MemAlloc(sizeof(TCHAR) * (lstrlen(buf) + 1));
	if(ret != NULL){
		lstrcpy(ret, buf);
	}
	return ret;
}


/******************************************************************************

	AllocCopyN

	obt@mۂĎw蒷̕Rs[

******************************************************************************/

TCHAR *AllocCopyN(TCHAR *buf, int size)
{
	TCHAR *ret;

	if(buf == NULL){
		return NULL;
	}
	ret = (TCHAR *)MemAlloc(sizeof(TCHAR) * (size + 1));
	if(ret != NULL){
		TStrCpyN(ret, buf, size);
	}
	return ret;
}


/******************************************************************************

	AllocJoin

	obt@mۂĕA

******************************************************************************/

TCHAR *AllocJoin(const TCHAR *buf1, const TCHAR *buf2)
{
	TCHAR *ret, *r;

	if(buf2 == NULL){
		return AllocCopy(buf1);
	}
	if(buf1 == NULL){
		return AllocCopy(buf2);
	}
	ret = MemAlloc(sizeof(TCHAR) * (lstrlen(buf1) + lstrlen(buf2) + 1));
	if(ret == NULL){
		return NULL;
	}
	r = TStrCpy(ret, buf1);
	lstrcpy(r, buf2);
	return ret;
}
/* End of source */
