/**************************************************************************

	ns

	main.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>
#include <winsock.h>

#ifdef _WIN32_WCE_PPC
#include "stdafx.h"
#endif

#ifdef _WIN32_WCE_LAGENDA
#include <SipApi.h>
#include <CoSipApi.h>
#include <COShellAPI.h>
#include <CS.h>
#include <CSO.h>
#endif

#ifdef UNICODE
#include <tchar.h>
#include <stdlib.h>
#endif

#include "resource.h"

#include "script.h"
#include "script_memory.h"
#include "script_string.h"
#include "script_utility.h"

#include "memory.h"
#include "string.h"
#include "view.h"


/**************************************************************************
	Define
**************************************************************************/

#define WINDOW_TITLE			TEXT("ns")
#define MAIN_WND_CLASS			TEXT("nsMain")

#define IDC_CB					2000
#define IDC_VIEW				2001

#define ID_EXIT_TIMER			1
#define ID_EXEC_TIMER			2
#define TIMER_INTERVAL			1000

#define VIEW_LIMIT				32768


/**************************************************************************
	Global Variables
**************************************************************************/

static HINSTANCE hInst;
static HWND hwndCB;
static HWND hwndEDIT;
static int menu_height;

static TCHAR *cmdLine = NULL;
static TCHAR *AppDir = NULL;

static SCRIPTINFO *ScriptInfo;

static BOOL op_explicit = FALSE;

#ifdef _WIN32_WCE_LAGENDA
static BOOL SipFlag = FALSE;
#endif


/**************************************************************************
	Local Function Prototypes
**************************************************************************/


/******************************************************************************

	GetAppPath

	[UfBNg̍쐬

******************************************************************************/

static BOOL GetAppPath(HINSTANCE hinst)
{
#ifdef _WCE_OLD
#define SAVEPATH	TEXT("\\My Documents\\")
	AppDir = AllocCopy(SAVEPATH);
	if(AppDir == NULL){
		return FALSE;
	}
#else
	TCHAR *p, *r;

	AppDir = (TCHAR *)LocalAlloc(LPTR, sizeof(TCHAR) * BUF_SIZE);
	if(AppDir == NULL){
		return FALSE;
	}

	//AvP[ṼpX擾
	GetModuleFileName(hinst, AppDir, BUF_SIZE - 1);
	for(p = r = AppDir;*p != TEXT('\0');p++){
		if(*p == TEXT('\\')){
			r = p;
		}
	}
	*r = TEXT('\0');

	lstrcat(AppDir, TEXT("\\"));
#endif
	return TRUE;
}


/******************************************************************************

	GetFileName

	t@C̎擾

******************************************************************************/

static BOOL GetFileName(HWND hWnd, TCHAR *ret)
{
	OPENFILENAME of;
	TCHAR path[BUF_SIZE];
	TCHAR *ph;

	lstrcpy(path, ret);
	ZeroMemory(&of, sizeof(OPENFILENAME));
	of.lStructSize = sizeof(OPENFILENAME);
	of.hInstance = hInst;
	of.hwndOwner = hWnd;
	of.lpstrFilter = TEXT("Script file (*.ns)\0*.ns\0All file (*.*)\0*.*\0\0");
	of.nFilterIndex = 1;
	of.lpstrTitle = TEXT("Open");
	of.lpstrFile = path;
	of.nMaxFile = BUF_SIZE - 1;
	of.lpstrDefExt = TEXT("ns");
	of.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	if(GetOpenFileName((LPOPENFILENAME)&of) == FALSE){
		return FALSE;
	}
	ph = path;
	if(*ph == TEXT('\\') && *(ph + 1) == TEXT('\\')){
		ph++;
	}
	if(*(ph + lstrlen(ph)) == TEXT('.')){
		*(ph + lstrlen(ph)) = TEXT('\0');
	}
	lstrcpy(ret, ph);
	return TRUE;
}


/******************************************************************************

	ReadScript

	XNvg̓ǂݍ

******************************************************************************/
BOOL SetCurrentDirectory(TCHAR *path);

static BOOL ReadScript(HWND hWnd, TCHAR *rfile)
{
	TCHAR *p, *r;
	TCHAR path[256];
	TCHAR file[256];
	TCHAR title[256];

	TerminateScript();
	ScriptWait();
	FreeScriptInfo(ScriptInfo);

	ScriptInfo = (SCRIPTINFO *)mem_alloc(sizeof(SCRIPTINFO));
	InitializeScriptInfo(ScriptInfo, op_explicit);
	ScriptInfo->param1 = (long)hWnd;

	if(rfile == NULL || *rfile == TEXT('\0')){
		lstrcpy(path, TEXT("*.ns"));
		if(GetFileName(hWnd, path) == FALSE){
			ScriptUnWait();
			return FALSE;
		}
		rfile = path;
	}else{
		lstrcpy(path, rfile);
	}
	for(p = r = path; *p != TEXT('\0'); p++){
		if(*p == TEXT('\\')){
			r = p;
		}
	}
	if(*r != TEXT('\\')){
		lstrcpy(file, rfile);
		lstrcpy(path, AppDir);
	}else{
		r++;
		lstrcpy(file, r);
		*r = TEXT('\0');
	}

#ifdef UNICODE
	{
		char *c1, *c2;
		c1 = tchar2char(path);
		c2 = tchar2char(file);
		ReadScriptFile(ScriptInfo, c1, c2);
		mem_free(&c1);
		mem_free(&c2);
	}
#else
	ReadScriptFile(ScriptInfo, path, file);
#endif
	ScriptUnWait();

	SetCurrentDirectory(path);

	wsprintf(title, TEXT("%s - [%s]"), WINDOW_TITLE, file);
	SetWindowText(hWnd, title);

	ExecGlobalArea(ScriptInfo);
	return TRUE;
}


/******************************************************************************

	ExecScript

	XNvg̎s

******************************************************************************/

static void ExecScript(HWND hWnd, VALUEINFO *vi)
{
	CreateScriptThread(ScriptInfo->next, NULL, "main", vi, FALSE, 0);
}


/******************************************************************************

	StrSkip

	̏Iʒu̎擾

******************************************************************************/

static TCHAR *StrSkip(TCHAR *p)
{
	//̓XLbv
	for(p++; *p != TEXT('\0') && *p != TEXT('\"'); p++){
#ifndef UNICODE
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			//2oCgR[hXLbv
			p++;
			if(*p == TEXT('\0')) break;
			continue;
		}
#endif
		if(*p == TEXT('\\')){
			p++;
			if(*p == TEXT('\0')){
				break;
			}
		}
	}
	return p;
}


/******************************************************************************

	IsCommandLineOption

	R}hC̃IvV݂邩`FbN

******************************************************************************/

static BOOL IsCommandLineOption(TCHAR *cmdstr, TCHAR lc, TCHAR uc)
{
	TCHAR *r;

	if(cmdstr == NULL || *cmdstr == TEXT('\0')){
		return FALSE;
	}
	for(r = cmdstr; *r == TEXT(' '); r++);
	while(*r == TEXT('/') || *r == TEXT('-')){
		for(; *r != TEXT('\0') && *r != TEXT(' ') && *r != lc && *r != uc; r++);
		if(*r == lc || *r == uc){
			return TRUE;
		}
		for(; *r == TEXT(' '); r++);
	}
	return FALSE;
}


/******************************************************************************

	ExecScript

	XNvg̎s

******************************************************************************/

static int StartExecScript(HWND hWnd, TCHAR *cmdstr)
{
	VALUEINFO pvi;
	VALUEINFO *vi;
	TCHAR *sfile;
	TCHAR *p, *r, *s;
	int i = 0;
	int ret = 0;

	op_explicit = IsCommandLineOption(cmdstr, TEXT('e'), TEXT('E'));
	if(IsCommandLineOption(cmdstr, TEXT('x'), TEXT('X')) == TRUE){
		ret |= 1;
	}
	for(p = cmdstr; *p == TEXT(' '); p++);
	while(*p == TEXT('/') || *p == TEXT('-')){
		for(; *p != TEXT('\0') && *p != TEXT(' '); p++);
		for(; *p == TEXT(' '); p++);
	}
	if(*p == TEXT('\0')){
		ret |= 1;
		return ret;
	}

	//XNvgt@C
	for(; *p == TEXT(' '); p++);
	if(*p == TEXT('\"')){
		r = StrSkip(p);
		p++;
	}else{
		for(r = p; *r != TEXT('\0') && *r != TEXT(' '); r++);
	}
	sfile = AllocCopyN(p, r - p + 1);
	p = (*r == TEXT('\"')) ? r + 1 : r;

	//R}hC
	pvi.next = NULL;
	vi = &pvi;
	while(*p != TEXT('\0')){
		for(; *p == TEXT(' '); p++);
		if(*p == TEXT('\"')){
			r = StrSkip(p);
			p++;
		}else{
			for(r = p; *r != TEXT('\0') && *r != TEXT(' '); r++);
		}
		vi = vi->next = AllocValue();
		vi->v->Type = TYPE_STRING;
		s = AllocCopyN(p, r - p + 1);
		vi->v->u.Value = tchar2char(s);
		MemFree(&s);
		p = (*r == TEXT('\"')) ? r + 1 : r;
	}

	ReadScript(hWnd, sfile);
	ExecScript(hWnd, pvi.next);
	FreeValueList(pvi.next);
	MemFree(&sfile);
	return ret;
}


/******************************************************************************

	SetWindowSize

	EBhẼTCYύX

******************************************************************************/

#ifdef _WIN32_WCE_PPC
static void SetWindowSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	RECT rcClient;

	GetClientRect(hWnd, &rcClient);
	MoveWindow(hwndEDIT, 0, 0,
		rcClient.right, rcClient.bottom, TRUE);
}
#endif
#ifdef _WIN32_WCE_LAGENDA
static void SetWindowSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	COSIPINFO CoSipInfo;
	SIPINFO SipInfo;
	RECT rcClient;
	int sip_height = 0;

	memset(&SipInfo, 0, sizeof(SIPINFO));
	SipInfo.cbSize = sizeof(SIPINFO);
	memset(&CoSipInfo, 0, sizeof(COSIPINFO));
	CoSipInfo.dwInfoType = COSIP_GET_KBTYPE;
	SipInfo.pvImData = &CoSipInfo;
	SipInfo.dwImDataSize = sizeof(COSIPINFO);
	SipGetInfo(&SipInfo);
	if(SipInfo.fdwFlags & SIPF_ON){
		sip_height = ((SipInfo.rcSipRect).bottom - (SipInfo.rcSipRect).top);
		SipFlag = TRUE;
	}else{
		SipFlag = FALSE;
	}

	GetClientRect(hWnd, &rcClient);
	MoveWindow(hwndEDIT, 0, menu_height,
		rcClient.right, rcClient.bottom - menu_height - sip_height, TRUE);
}
#endif


/******************************************************************************

	WndProc

	CEBhEvV[W

******************************************************************************/

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	RECT rect;
#ifdef _WIN32_WCE_PPC
	SHMENUBARINFO mbi;
	static BOOL SipFlag = FALSE;
#endif
#ifdef _WIN32_WCE_LAGENDA
	CSOBAR_BASEINFO		BaseInfo = {
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		1,											// line
		CSOBAR_DEFAULT_BACKCOLOR,					// backColor
		CSOBAR_DEFAULT_CODECOLOR,					// titleColor
		NULL,										// titleText
		0,										// titleBmpResId
		NULL,										// titleBmpResIns
	};
	CSOBAR_BUTTONINFO	ButtonInfo[] = {
		1, CSOBAR_BUTTON_SUBMENU_DOWN,  CSO_BUTTON_DISP, (-1),        NULL,      TEXT("t@C"), NULL,   CSOBAR_CODEPOS_CENTER,            1, (-1), (-1), (-1), (-1), 0,              CLR_INVALID, CLR_INVALID, CLR_INVALID, FALSE, FALSE,
		2, CSOBAR_BUTTON_SUBMENU_DOWN,  CSO_BUTTON_DISP, (-1),        NULL,      TEXT("ҏW"), NULL,   CSOBAR_CODEPOS_CENTER,            1, (-1), (-1), (-1), (-1), 0,              CLR_INVALID, CLR_INVALID, CLR_INVALID, FALSE, FALSE,
	};
	HWND hWndCSOBar;
	DWORD style;
#endif

	switch(message)
	{
	case WM_CREATE:
		SendMessage(hWnd, WM_SETICON, (WPARAM)FALSE,
			(LPARAM)LoadImage(hInst, MAKEINTRESOURCE(IDI_NS), IMAGE_ICON, 16, 16, 0));

#ifdef _WIN32_WCE_PPC
		memset (&mbi, 0, sizeof (SHMENUBARINFO));
		mbi.cbSize     = sizeof (SHMENUBARINFO);
		mbi.hwndParent = hWnd;
		mbi.nToolBarId = IDR_MENU_PPC;
		mbi.hInstRes   = hInst;
		mbi.nBmpId     = 0;
		mbi.cBmpImages = 0;
		SHCreateMenuBar(&mbi);
		menu_height = 0;
#elif defined _WIN32_WCE_LAGENDA
		hWndCSOBar = CSOBar_Create(hInst, hWnd, 1, BaseInfo);
		CSOBar_AddAdornments(hWndCSOBar, hInst, 1, CSOBAR_ADORNMENT_CLOSE, 0);

		ButtonInfo[0].SubMenu = GetSubMenu(LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENU_PPC)), 0);
		ButtonInfo[1].SubMenu = GetSubMenu(LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENU_PPC)), 1);
		CSOBar_AddButtons(hWndCSOBar, hInst, 2, ButtonInfo);

		style = GetWindowLong(hWndCSOBar, GWL_STYLE);
		style &= ~WS_CLIPCHILDREN;
		SetWindowLong(hWndCSOBar, GWL_STYLE, style);

		menu_height = CSOBar_Height(hWndCSOBar);
#else
		if(IsCommandLineOption(cmdLine, TEXT('m'), TEXT('M')) == FALSE){
			hwndCB = CommandBar_Create(hInst, hWnd, IDC_CB);
			CommandBar_InsertMenubar(hwndCB, hInst, IDM_MENU, 0);
			CommandBar_AddAdornments(hwndCB, 0, 0);
			menu_height = CommandBar_Height(hwndCB);
		}else{
			menu_height = 0;
		}
#endif

		GetClientRect(hWnd, &rect);
		hwndEDIT = CreateWindowEx(0,
			VIEW_WND_CLASS, TEXT(""),
			WS_TABSTOP | WS_VISIBLE | WS_CHILD | ES_MULTILINE | ES_NOHIDESEL | WS_VSCROLL,
			0, menu_height, rect.right, rect.bottom - menu_height,
			hWnd, (HMENU)IDC_VIEW, hInst, NULL);
		SendMessage(hwndEDIT, EM_LIMITTEXT, VIEW_LIMIT, 0);

		if(cmdLine != NULL && *cmdLine != TEXT('\0')){
			if(!(StartExecScript(hWnd, cmdLine) & 1)){
#ifdef _WIN32_WCE_PPC
				EnableMenuItem(SHGetSubMenu(mbi.hwndMB, IDM_MENU_FILE), ID_MENUITEM_OPEN, MF_GRAYED);
#else
				EnableMenuItem(CommandBar_GetMenu(hwndCB, 0), ID_MENUITEM_OPEN, MF_GRAYED);
#endif
				SetTimer(hWnd, ID_EXIT_TIMER, TIMER_INTERVAL, NULL);
			}
		}
		break;

	case WM_TIMER:
		switch(wParam)
		{
		case ID_EXIT_TIMER:
			if(GetExecFuncCnt() <= 0){
				KillTimer(hWnd, ID_EXIT_TIMER);
				SendMessage(hWnd, WM_CLOSE, 0, 0);
			}
			break;

		case ID_EXEC_TIMER:
			if(GetExecFuncCnt() <= 0){
				KillTimer(hWnd, ID_EXIT_TIMER);
				SetWindowText(hWnd, WINDOW_TITLE);
			}
			break;
		}
		break;

	case WM_CLOSE:
		TerminateScript();
		FreeScriptInfo(ScriptInfo);
		ScriptInfo = NULL;

#ifndef _WIN32_WCE_PPC
		CommandBar_Destroy(hwndCB);
#endif
#ifdef _WIN32_WCE_LAGENDA
		SipShowIM(SIPF_OFF);
		CoshMainMenuExec(hWnd);
#endif
		DestroyWindow(hwndEDIT);
		DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

#ifdef _WIN32_WCE_PPC
	case WM_SETTINGCHANGE:
		if(SPI_SETSIPINFO == wParam){
			SHACTIVATEINFO sai;

			memset(&sai, 0, sizeof(SHACTIVATEINFO));
			SHHandleWMSettingChange(hWnd, -1, 0, &sai);
			if(GetForegroundWindow() == hWnd){
				SipFlag = sai.fSipUp;
			}
			SetWindowSize(hWnd, 0, 0);
		}
		break;
#elif defined _WIN32_WCE_LAGENDA
	case WM_SETTINGCHANGE:
		if(SPI_SETSIPINFO == wParam){
			SetWindowSize(hWnd, 0, 0);
		}
		break;
#endif

	case WM_SETFOCUS:
#ifdef _WIN32_WCE_PPC
		SHSipPreference(hWnd, (SipFlag) ? SIP_UP : SIP_DOWN);
#elif defined _WIN32_WCE_LAGENDA
		SipShowIM((SipFlag) ? SIPF_ON : SIPF_OFF);
#endif
		SetFocus(hwndEDIT);
		break;

	case WM_ADDTEXT:
	case WM_GETS:
	case WM_GETCHAR:
	case WM_SETECHO:
		SendMessage(hwndEDIT, message, 0, lParam);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case ID_MENUITEM_OPEN:
			SendMessage(hwndEDIT, WM_INITVIEW, 0, 0);
			if(ReadScript(hWnd, NULL) == TRUE){
				ExecScript(hWnd, NULL);
			}
			SetTimer(hWnd, ID_EXEC_TIMER, TIMER_INTERVAL, NULL);
			break;

		case ID_MENUITEM_STOP:
			TerminateScript();
			break;

		case IDM_FILE_EXIT:
#ifdef _WIN32_WCE_LAGENDA
		case CSOBAR_ADORNMENTID_CLOSE:
#endif
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;

		case ID_MENUITEM_COPY:
			SendMessage(hwndEDIT, WM_COPY, 0, 0);
			break;

		case ID_MENUITEM_PASTE:
			SendMessage(hwndEDIT, WM_PASTE, 0, 0);
			break;

		case ID_MENUITEM_SELECTALL:
			SendMessage(hwndEDIT, EM_SETSEL, 0, -1);
			break;
		}
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


/******************************************************************************

	InitApplication

	EBhENX̓o^

******************************************************************************/

static BOOL InitApplication(HINSTANCE hInstance)
{
	WNDCLASS wc;

    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = (WNDPROC)WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_NS));
    wc.hCursor = 0;
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    wc.lpszMenuName = 0;
    wc.lpszClassName = MAIN_WND_CLASS;
	return RegisterClass(&wc);
}


/******************************************************************************

	InitInstance

	EBhE̍쐬

******************************************************************************/

static BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;
#ifdef _WIN32_WCE_PPC
	SIPINFO si;
	int x = CW_USEDEFAULT, y = CW_USEDEFAULT, cx, cy;
#endif

#ifdef _WIN32_WCE_PPC
	memset(&si, 0, sizeof(si));
	si.cbSize = sizeof(si);
	SHSipInfo(SPI_GETSIPINFO, 0, &si, 0);
	cx = si.rcVisibleDesktop.right - si.rcVisibleDesktop.left;
	cy = si.rcVisibleDesktop.bottom - si.rcVisibleDesktop.top - ((si.fdwFlags & SIPF_ON) ? 0 : MENU_HEIGHT);

	hWnd = CreateWindow(MAIN_WND_CLASS,
		WINDOW_TITLE,
		WS_VISIBLE,
		x, y, cx, cy,
		NULL, NULL, hInstance, NULL);
#else
	hWnd = CreateWindow(MAIN_WND_CLASS, WINDOW_TITLE, WS_VISIBLE,
		0, 0, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
#endif

	if(!hWnd){	
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	return TRUE;
}


/******************************************************************************

	WinMain

	C

******************************************************************************/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;
	WSADATA WsaData;

	hInst = hInstance;

#if defined(_WIN32_WCE_PPC) || defined(_WIN32_WCE_LAGENDA)
	{
		HWND hWnd;
		//QdNNh~
		if((hWnd = FindWindow(MAIN_WND_CLASS, NULL)) != NULL){
			ShowWindow(hWnd, SW_SHOW);
			SetForegroundWindow(hWnd);
			return 0;
		}
	}
#endif

	cmdLine = AllocCopy(lpCmdLine);

	//
	RegistViewWindow(hInstance);
	InitializeScript();
	if(WSAStartup(0x101, &WsaData) != 0){
		EndScript();
		MemFree(&cmdLine);
		return 0;
	}
	InitCommonControls();

	if(GetAppPath(hInstance) == FALSE){
		EndScript();
		WSACleanup();
		MemFree(&cmdLine);
		return 0;
	}

	//EBhE쐬
	if(!InitApplication(hInstance)){
		EndScript();
		WSACleanup();
		MemFree(&cmdLine);
		return 0;
	}
	if(!InitInstance(hInstance, nCmdShow)){
		EndScript();
		WSACleanup();
		MemFree(&cmdLine);
		return 0;
	}
	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_NS);

	while(GetMessage(&msg, NULL, 0, 0)){
		if(!TranslateAccelerator(GetForegroundWindow(), hAccelTable, &msg)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	EndScript();
	WSACleanup();
	MemFree(&cmdLine);
	return msg.wParam;
}
/* End of source */
